<template>
  <div class="container">
    <h1 class="text-success mt-3">{{ title }}</h1>

    <div class="d-flex align-content-center mt-3">
      <h4>Sorteio:</h4>
      <p class="ball ball-active" v-for="numberPicker in pickedNumbers">{{ numberPicker }}</p>
    </div>

    <div class="mb-5">
      <b-button variant="primary" class="mr-3" :disabled="loading" @click="generatePickedNumbers">
        Iniciar sorteio
      </b-button>

      <b-button variant="outline-primary" :disabled="loading" @click="generateRandomGames">
        Gerar novos números
      </b-button>
    </div>

    <h4 class="mb-3">Meus jogos</h4>

    <div class="d-flex align-content-center" v-for="(game, index) in games">
      <h4>{{ index }}:</h4>
      <p class="ball ball-default" :class="{ 'ball-active': checkNumberInLottery(item) }" v-for="item in game">{{
        item }}</p>
    </div>

    <div class="mb-3">
      <b-button variant="outline-primary" class="mr-3" :disabled="loading" @click="showModal">
        + Novo jogo
      </b-button>
    </div>

    <b-modal id="newGame" size="lg" hide-footer title="Novo jogo">
      <p class="text-info h4 text-center font-bold">
        Informe os seus seis números desejados!
      </p>

      <b-row>
        <b-col v-for="(num, index) in numbersTemp" :key="index">
          <label>Número:</label>
          <b-form-input type="number" :name="'num'+index" v-model="numbersTemp[index]" min="1" max="60"
                        :class="{ 'is-invalid': checkNumberCustom(num) }"></b-form-input>
        </b-col>
      </b-row>

      <div class="text-center">
        <button type="submit" class="btn btn-success mt-3" @click="confirmNewGame" :disabled="numbersUnique">
          Confirmar novo jogo
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script>
  import {interval} from 'rxjs';
  import {map, take} from 'rxjs/operators';

  export default {
    name: 'app',
    data() {
      return {
        title: 'Sorteio da megasena',
        numbersTemp: [],
        pickedNumbers: [],
        loading: false,
        numbersUnique: false,
        customGames: [],
        games: []
      }
    },
    computed: {},
    mounted() {
      this.generateRandomGames()
    },
    methods: {
      /**
       * Método para verificar se o número está no array
       */
      numberInArray: function (number, array) {
        return array && !!array.length && array.indexOf(number) !== -1
      },

      /**
       * Método para gerar números aleatórios
       */
      randomNumber: function (min, max) {
        return Math.floor(Math.random() * max + min)
      },

      /**
       * Método para gerar os números aleatórios até uma quantidade definida
       */
      randomNumbers: function (min, max, count) {
        const numbers = [];

        for (let i = 0; i < count; i++) {
          const number = Math.floor(this.randomNumber(min, max));
          if (numbers.indexOf(number) === -1) numbers.push(number)
          else i--
        }

        return numbers.sort((a, b) => a > b)
      },

      /**
       * Método para checar se o número sorteado está no array de jogos
       */
      checkNumberInLottery: function (number) {
        return this.numberInArray(number, this.pickedNumbers)
      },

      /**
       * Método para checar se o número é único
       */
      checkNumberCustom: function (number) {
        let count = {}

        // Verifica quantas vezes o número aparece no array
        this.numbersTemp.forEach(function (i) {
          count[i] = (count[i] || 0) + 1;
        })
        this.checkNumberUniqueinArray()
        return count[number] > 1
      },

      /**
       * Método para verificar se existe um número repetido no jogo customizado
       */
      checkNumberUniqueinArray: function () {
        let count = {}
        var duplicated = false

        // Verifica quantas vezes o número aparece no array
        this.numbersTemp.forEach(function (i) {
          count[i] = (count[i] || 0) + 1;
        })

        // Verifica se o número aparece mais que 1 vez no array e marca como duplicado
        Object.keys(count).forEach(function (i) {
          if (count[i] > 1) {
            duplicated = true
          }
        })

        this.numbersUnique = duplicated
      },

      /**
       * Método para gerar os 6 números sorteados e verifica se não há números repetidos já sorteados
       */
      generatePickedNumbers: function () {
        // Desabilita os botões da tela enquanto faz o sorteio e limpa o array de números sorteados
        this.loading = true
        this.pickedNumbers = []

        let numberLocal = undefined

        // Observable
        const pickedNumbers$ = interval(1000).pipe(
          map(() => {
            /**
             * Considero o número inválido por padrão
             */
            let numberOk = false

            /**
             * Enquanto o número for inválido,
             * gero um novo número aleatório.
             */
            while (!numberOk) {
              const newNumber = this.randomNumber(1, 60)

              /**
               * Validação do número recém gerado
               */
              if (this.pickedNumbers.indexOf(newNumber) === -1) {
                numberLocal = newNumber
                numberOk = true
              }
            }
          }),
          take(6)
        );

        pickedNumbers$.subscribe(() => {
            // Preenche o array de números sorteados e habilita os botões novamente
            this.pickedNumbers.push(numberLocal)
            this.loading = false
          }
        );
      },

      /**
       * Método para gerar jogos aleatórios
       */
      generateRandomGames: function () {
        // Gera jogos aleatórios com o tamanho de 'numberOfGames', além de zerar os arrays de games e números sorteados
        let numberOfGames = 3
        this.games = []
        this.pickedNumbers = []

        for (let i = 0; i < numberOfGames; i++) {
          this.games.push(this.randomNumbers(1, 60, 6))
        }
      },

      /**
       * Método para exibir o modal de novo jogo
       */
      showModal: function () {
        // Deixando o array de números temporários zerado e exibindo o modal
        this.numbersTemp = []
        this.numbersUnique = false
        this.$bvModal.show('newGame')

        // O array de números temporáios está sendo preenchido com núemros aleatórios
        this.numbersTemp = this.randomNumbers(1, 60, 6)
      },

      /**
       * Método para adicionar o novo jogo do usuário na listagem de jogos
       */
      confirmNewGame: function () {
        // Deixando os arrays de jogos customizados e números sorteados zerados
        this.customGames = []
        this.pickedNumbers = []

        //Atualizando o array de jogos customizados com os números temporários do formulário
        this.customGames.push(this.numbersTemp)

        // Atualizando a lista de jogos e escondendo o modal
        this.games.push(this.customGames[0])
        this.$bvModal.hide('newGame')

        // Deixando o array de números temporários zerado
        this.numbersTemp = []
        this.numbersUnique = false
      }
    }
  }
</script>

<style>
  .ball {
    width: 50px;
    height: 50px;
    border-radius: 50%;
    font-size: 22px;
    line-height: 45px;
    font-weight: bold;
    text-align: center;
    margin-left: 10px;
    padding: 0;
    box-sizing: border-box;
  }

  .ball-default {
    background-color: #fff;
    border: 2px solid #ccc;
    color: #333;
  }

  .ball-active {
    background-color: #75cc54;
    border: 2px solid #75cc54;
    color: #fff;
  }
</style>
